import core from '@/core'

export default (src, options, useViewer, docNum) => {
  const documentViewer = core.getDocumentViewer(docNum)

  options.checkPassword = passwordOption(options.password, useViewer)

  return documentViewer.loadDocument(src, options)
}

function passwordOption(password, useViewer) {
  let passwordChecked = false;
  let attempt = 0;

  return (checkPassword) => {
    attempt++
    if (!passwordChecked && typeof password === 'string') {
      checkPassword(password);
      passwordChecked = true;
    } else {
      if (passwordChecked) {
        console.error(
          'Wrong password has been passed as an argument. WebViewer will open password modal.',
        );
      }

      setCheckPasswordFunction(checkPassword);
      useViewer.openElement('passwordModal')
    }
  }
}
const setCheckPasswordFunction = (fn) => {
  checkPassword = fn;
}

export let checkPassword = () => { };
